<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/gamestates/GameState.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_a965fb386e4455e156591f466d68ffdd.html">gamestates</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">GameState.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="GameState_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;<a class="code" href="Event_8hpp.html">core/Event.hpp</a>&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &lt;<a class="code" href="GameEngine_8hpp.html">core/GameEngine.hpp</a>&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;<a class="code" href="Scene_8hpp.html">gui/Scene.hpp</a>&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="preprocessor">#include &lt;<a class="code" href="SceneManager_8hpp.html">resources/SceneManager.hpp</a>&gt;</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>{</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span> </div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html">   11</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1GameState.html">GameState</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a>, <span class="keyword">public</span> sf::Drawable</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>{</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a5f1b188a3cb1ecb87ee511eb94bac00a">   14</a></span>    <a class="code hl_function" href="classgg_1_1GameState.html#a5f1b188a3cb1ecb87ee511eb94bac00a">GameState</a>(<a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a>);</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a002bb6e63a30011a1994f94a174f78dd">   15</a></span>    <a class="code hl_function" href="classgg_1_1GameState.html#a002bb6e63a30011a1994f94a174f78dd">~GameState</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#aa5b20ea0224f8a5fde426cecc5c58663">   17</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameState.html#aa5b20ea0224f8a5fde426cecc5c58663">Enter</a>();</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a1bd8ba8c1de8c6d955266c06366b945e">   18</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameState.html#a1bd8ba8c1de8c6d955266c06366b945e">Exit</a>();</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a9ecdbb073943b30d3761441a64c287f2">   20</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameState.html#a9ecdbb073943b30d3761441a64c287f2">Update</a>() = 0;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a889abdb1cbc9d27df5b6ea25dae3942b">   22</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1GameState.html#a889abdb1cbc9d27df5b6ea25dae3942b">GetSceneType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a>;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>  <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#a73aefae71e9c2b1d25570209eb8060ba">   25</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameState.html#a73aefae71e9c2b1d25570209eb8060ba">draw</a>(sf::RenderTarget &amp;target, sf::RenderStates states) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>  <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="classgg_1_1GameState.html#aff73b97ff10df8d9e2adc87adb946721">   28</a></span>    <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a> <a class="code hl_variable" href="classgg_1_1GameState.html#aff73b97ff10df8d9e2adc87adb946721">m_sceneType</a> = <a class="code hl_enumvalue" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af">SceneType::Custom</a>;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>};</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aEvent_8hpp_html"><div class="ttname"><a href="Event_8hpp.html">Event.hpp</a></div></div>
<div class="ttc" id="aGameEngine_8hpp_html"><div class="ttname"><a href="GameEngine_8hpp.html">GameEngine.hpp</a></div></div>
<div class="ttc" id="aSceneManager_8hpp_html"><div class="ttname"><a href="SceneManager_8hpp.html">SceneManager.hpp</a></div></div>
<div class="ttc" id="aScene_8hpp_html"><div class="ttname"><a href="Scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1GameState_html"><div class="ttname"><a href="classgg_1_1GameState.html">gg::GameState</a></div><div class="ttdef"><b>Definition:</b> GameState.hpp:12</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a002bb6e63a30011a1994f94a174f78dd"><div class="ttname"><a href="classgg_1_1GameState.html#a002bb6e63a30011a1994f94a174f78dd">gg::GameState::~GameState</a></div><div class="ttdeci">~GameState() override=default</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a1bd8ba8c1de8c6d955266c06366b945e"><div class="ttname"><a href="classgg_1_1GameState.html#a1bd8ba8c1de8c6d955266c06366b945e">gg::GameState::Exit</a></div><div class="ttdeci">virtual void Exit()</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a5f1b188a3cb1ecb87ee511eb94bac00a"><div class="ttname"><a href="classgg_1_1GameState.html#a5f1b188a3cb1ecb87ee511eb94bac00a">gg::GameState::GameState</a></div><div class="ttdeci">GameState(SceneType)</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a73aefae71e9c2b1d25570209eb8060ba"><div class="ttname"><a href="classgg_1_1GameState.html#a73aefae71e9c2b1d25570209eb8060ba">gg::GameState::draw</a></div><div class="ttdeci">void draw(sf::RenderTarget &amp;target, sf::RenderStates states) const override</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a889abdb1cbc9d27df5b6ea25dae3942b"><div class="ttname"><a href="classgg_1_1GameState.html#a889abdb1cbc9d27df5b6ea25dae3942b">gg::GameState::GetSceneType</a></div><div class="ttdeci">auto GetSceneType() -&gt; SceneType</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_a9ecdbb073943b30d3761441a64c287f2"><div class="ttname"><a href="classgg_1_1GameState.html#a9ecdbb073943b30d3761441a64c287f2">gg::GameState::Update</a></div><div class="ttdeci">virtual void Update()=0</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_aa5b20ea0224f8a5fde426cecc5c58663"><div class="ttname"><a href="classgg_1_1GameState.html#aa5b20ea0224f8a5fde426cecc5c58663">gg::GameState::Enter</a></div><div class="ttdeci">virtual void Enter()</div></div>
<div class="ttc" id="aclassgg_1_1GameState_html_aff73b97ff10df8d9e2adc87adb946721"><div class="ttname"><a href="classgg_1_1GameState.html#aff73b97ff10df8d9e2adc87adb946721">gg::GameState::m_sceneType</a></div><div class="ttdeci">SceneType m_sceneType</div><div class="ttdef"><b>Definition:</b> GameState.hpp:28</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html">gg::IEventSubscriber</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:59</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a185920557ea920066338d5dec2aa9cf9"><div class="ttname"><a href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">gg::SceneType</a></div><div class="ttdeci">SceneType</div><div class="ttdef"><b>Definition:</b> SceneManager.hpp:8</div></div>
<div class="ttc" id="anamespacegg_html_a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af"><div class="ttname"><a href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af">gg::SceneType::Custom</a></div><div class="ttdeci">@ Custom</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
